#ifndef INCLUDED_COM_SUN_STAR_LINGUISTIC2_GRAMMARCHECKINGRESULT_HPP
#define INCLUDED_COM_SUN_STAR_LINGUISTIC2_GRAMMARCHECKINGRESULT_HPP

#include "sal/config.h"

#include "com/sun/star/linguistic2/GrammarCheckingResult.hdl"

#include "com/sun/star/linguistic2/XGrammarChecker.hpp"
#include "com/sun/star/lang/Locale.hpp"
#include "com/sun/star/text/XFlatParagraph.hpp"
#include "com/sun/star/linguistic2/SingleGrammarError.hpp"
#include "com/sun/star/uno/Reference.hxx"
#include "com/sun/star/uno/Sequence.hxx"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "rtl/ustring.hxx"
#include "sal/types.h"
#include "typelib/typeclass.h"
#include "typelib/typedescription.h"

namespace com { namespace sun { namespace star { namespace linguistic2 {

inline GrammarCheckingResult::GrammarCheckingResult() SAL_THROW( () )
    : nDocumentId(0)
    , xFlatParagraph()
    , aText()
    , aLocale()
    , nStartOfSentencePos(0)
    , nEndOfSentencePos(0)
    , aGrammarErrors()
    , xGrammarChecker()
{
}

inline GrammarCheckingResult::GrammarCheckingResult(const ::sal_Int32& nDocumentId_, const ::com::sun::star::uno::Reference< ::com::sun::star::text::XFlatParagraph >& xFlatParagraph_, const ::rtl::OUString& aText_, const ::com::sun::star::lang::Locale& aLocale_, const ::sal_Int32& nStartOfSentencePos_, const ::sal_Int32& nEndOfSentencePos_, const ::com::sun::star::uno::Sequence< ::com::sun::star::linguistic2::SingleGrammarError >& aGrammarErrors_, const ::com::sun::star::uno::Reference< ::com::sun::star::linguistic2::XGrammarChecker >& xGrammarChecker_) SAL_THROW( () )
    : nDocumentId(nDocumentId_)
    , xFlatParagraph(xFlatParagraph_)
    , aText(aText_)
    , aLocale(aLocale_)
    , nStartOfSentencePos(nStartOfSentencePos_)
    , nEndOfSentencePos(nEndOfSentencePos_)
    , aGrammarErrors(aGrammarErrors_)
    , xGrammarChecker(xGrammarChecker_)
{
}

} } } }

namespace com { namespace sun { namespace star { namespace linguistic2 {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::linguistic2::GrammarCheckingResult const *) {
    //TODO: On certain platforms with weak memory models, the following code can result in some threads observing that the_type points to garbage
    static ::typelib_TypeDescriptionReference * the_type = 0;
    if (the_type == 0) {
        ::typelib_TypeDescriptionReference * the_members[] = {
            ::cppu::UnoType< ::sal_Int32 >::get().getTypeLibType(),
            ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::text::XFlatParagraph > >::get().getTypeLibType(),
            ::cppu::UnoType< ::rtl::OUString >::get().getTypeLibType(),
            ::cppu::UnoType< ::com::sun::star::lang::Locale >::get().getTypeLibType(),
            ::cppu::UnoType< ::sal_Int32 >::get().getTypeLibType(),
            ::cppu::UnoType< ::sal_Int32 >::get().getTypeLibType(),
            ::cppu::UnoType< ::cppu::UnoSequenceType< ::com::sun::star::linguistic2::SingleGrammarError > >::get().getTypeLibType(),
            ::cppu::UnoType< ::com::sun::star::uno::Reference< ::com::sun::star::linguistic2::XGrammarChecker > >::get().getTypeLibType() };
        ::typelib_static_struct_type_init(&the_type, "com.sun.star.linguistic2.GrammarCheckingResult", 0, 8, the_members, 0);
    }
    return *reinterpret_cast< ::com::sun::star::uno::Type * >(&the_type);
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::linguistic2::GrammarCheckingResult const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::linguistic2::GrammarCheckingResult >::get();
}

#endif // INCLUDED_COM_SUN_STAR_LINGUISTIC2_GRAMMARCHECKINGRESULT_HPP
